]> git.ipfire.org Git - thirdparty/git.git/blob - t/test-lib.sh
unicode: update the width tables to Unicode 15.1
[thirdparty/git.git] / t / test-lib.sh
1 # Test framework for git. See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
24 TEST_DIRECTORY=$(pwd)
25 else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
31 #
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
37 fi
38 if test -z "$TEST_OUTPUT_DIRECTORY"
39 then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
43 fi
44 GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45 if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
46 then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
49 fi
50 if test -f "$GIT_BUILD_DIR/GIT-BUILD-DIR"
51 then
52 GIT_BUILD_DIR="$(cat "$GIT_BUILD_DIR/GIT-BUILD-DIR")" || exit 1
53 # On Windows, we must convert Windows paths lest they contain a colon
54 case "$(uname -s)" in
55 *MINGW*)
56 GIT_BUILD_DIR="$(cygpath -au "$GIT_BUILD_DIR")"
57 ;;
58 esac
59 fi
60
61 # Prepend a string to a VAR using an arbitrary ":" delimiter, not
62 # adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
63 #
64 # VAR=$1${VAR:+${1:+$2}$VAR}
65 #
66 # Usage (using ":" as the $2 delimiter):
67 #
68 # prepend_var VAR : VALUE
69 prepend_var () {
70 eval "$1=\"$3\${$1:+${3:+$2}\$$1}\""
71 }
72
73 # If [AL]SAN is in effect we want to abort so that we notice
74 # problems. The GIT_SAN_OPTIONS variable can be used to set common
75 # defaults shared between [AL]SAN_OPTIONS.
76 prepend_var GIT_SAN_OPTIONS : abort_on_error=1
77 prepend_var GIT_SAN_OPTIONS : strip_path_prefix="$GIT_BUILD_DIR/"
78
79 # If we were built with ASAN, it may complain about leaks
80 # of program-lifetime variables. Disable it by default to lower
81 # the noise level. This needs to happen at the start of the script,
82 # before we even do our "did we build git yet" check (since we don't
83 # want that one to complain to stderr).
84 prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
85 prepend_var ASAN_OPTIONS : detect_leaks=0
86 export ASAN_OPTIONS
87
88 prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
89 prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
90 export LSAN_OPTIONS
91
92 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
93 then
94 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
95 exit 1
96 fi
97 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
98 export PERL_PATH SHELL_PATH
99
100 # In t0000, we need to override test directories of nested testcases. In case
101 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
102 # reset this value to instead contain what the developer has specified. We thus
103 # have this knob to allow overriding the directory.
104 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
105 then
106 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
107 fi
108
109 # Disallow the use of abbreviated options in the test suite by default
110 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
111 then
112 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
113 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
114 fi
115
116 # Explicitly set the default branch name for testing, to avoid the
117 # transitory "git init" warning under --verbose.
118 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
119 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
120
121 ################################################################
122 # It appears that people try to run tests without building...
123 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
124 if test $? != 1
125 then
126 if test -n "$GIT_TEST_INSTALLED"
127 then
128 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
129 else
130 echo >&2 'error: you do not seem to have built git yet.'
131 fi
132 exit 1
133 fi
134
135 store_arg_to=
136 opt_required_arg=
137 # $1: option string
138 # $2: name of the var where the arg will be stored
139 mark_option_requires_arg () {
140 if test -n "$opt_required_arg"
141 then
142 echo "error: options that require args cannot be bundled" \
143 "together: '$opt_required_arg' and '$1'" >&2
144 exit 1
145 fi
146 opt_required_arg=$1
147 store_arg_to=$2
148 }
149
150 # These functions can be overridden e.g. to output JUnit XML
151 start_test_output () { :; }
152 start_test_case_output () { :; }
153 finalize_test_case_output () { :; }
154 finalize_test_output () { :; }
155
156 parse_option () {
157 local opt="$1"
158
159 case "$opt" in
160 -d|--d|--de|--deb|--debu|--debug)
161 debug=t ;;
162 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
163 immediate=t ;;
164 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
165 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
166 -r)
167 mark_option_requires_arg "$opt" run_list
168 ;;
169 --run=*)
170 run_list=${opt#--*=} ;;
171 -h|--h|--he|--hel|--help)
172 help=t ;;
173 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
174 verbose=t ;;
175 --verbose-only=*)
176 verbose_only=${opt#--*=}
177 ;;
178 -q|--q|--qu|--qui|--quie|--quiet)
179 # Ignore --quiet under a TAP::Harness. Saying how many tests
180 # passed without the ok/not ok details is always an error.
181 test -z "$HARNESS_ACTIVE" && quiet=t ;;
182 --with-dashes)
183 with_dashes=t ;;
184 --no-bin-wrappers)
185 no_bin_wrappers=t ;;
186 --no-color)
187 color= ;;
188 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
189 valgrind=memcheck
190 tee=t
191 ;;
192 --valgrind=*)
193 valgrind=${opt#--*=}
194 tee=t
195 ;;
196 --valgrind-only=*)
197 valgrind_only=${opt#--*=}
198 tee=t
199 ;;
200 --tee)
201 tee=t ;;
202 --root=*)
203 root=${opt#--*=} ;;
204 --chain-lint)
205 GIT_TEST_CHAIN_LINT=1 ;;
206 --no-chain-lint)
207 GIT_TEST_CHAIN_LINT=0 ;;
208 -x)
209 trace=t ;;
210 -V|--verbose-log)
211 verbose_log=t
212 tee=t
213 ;;
214 --write-junit-xml)
215 . "$TEST_DIRECTORY/test-lib-junit.sh"
216 ;;
217 --github-workflow-markup)
218 . "$TEST_DIRECTORY/test-lib-github-workflow-markup.sh"
219 ;;
220 --stress)
221 stress=t ;;
222 --stress=*)
223 echo "error: --stress does not accept an argument: '$opt'" >&2
224 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
225 exit 1
226 ;;
227 --stress-jobs=*)
228 stress=t;
229 stress_jobs=${opt#--*=}
230 case "$stress_jobs" in
231 *[!0-9]*|0*|"")
232 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
233 exit 1
234 ;;
235 *) # Good.
236 ;;
237 esac
238 ;;
239 --stress-limit=*)
240 stress=t;
241 stress_limit=${opt#--*=}
242 case "$stress_limit" in
243 *[!0-9]*|0*|"")
244 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
245 exit 1
246 ;;
247 *) # Good.
248 ;;
249 esac
250 ;;
251 --invert-exit-code)
252 invert_exit_code=t
253 ;;
254 *)
255 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
256 esac
257 }
258
259 # Parse options while taking care to leave $@ intact, so we will still
260 # have all the original command line options when executing the test
261 # script again for '--tee' and '--verbose-log' later.
262 for opt
263 do
264 if test -n "$store_arg_to"
265 then
266 eval $store_arg_to=\$opt
267 store_arg_to=
268 opt_required_arg=
269 continue
270 fi
271
272 case "$opt" in
273 --*|-?)
274 parse_option "$opt" ;;
275 -?*)
276 # bundled short options must be fed separately to parse_option
277 opt=${opt#-}
278 while test -n "$opt"
279 do
280 extra=${opt#?}
281 this=${opt%$extra}
282 opt=$extra
283 parse_option "-$this"
284 done
285 ;;
286 *)
287 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
288 esac
289 done
290 if test -n "$store_arg_to"
291 then
292 echo "error: $opt_required_arg requires an argument" >&2
293 exit 1
294 fi
295
296 if test -n "$valgrind_only"
297 then
298 test -z "$valgrind" && valgrind=memcheck
299 test -z "$verbose" && verbose_only="$valgrind_only"
300 elif test -n "$valgrind"
301 then
302 test -z "$verbose_log" && verbose=t
303 fi
304
305 if test -n "$stress"
306 then
307 verbose=t
308 trace=t
309 immediate=t
310 fi
311
312 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
313 TEST_NAME="$(basename "$0" .sh)"
314 TEST_NUMBER="${TEST_NAME%%-*}"
315 TEST_NUMBER="${TEST_NUMBER#t}"
316 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
317 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
318 TEST_RESULTS_SAN_FILE_PFX=trace
319 TEST_RESULTS_SAN_DIR_SFX=leak
320 TEST_RESULTS_SAN_FILE=
321 TEST_RESULTS_SAN_DIR="$TEST_RESULTS_DIR/$TEST_NAME.$TEST_RESULTS_SAN_DIR_SFX"
322 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP=
323 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
324 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
325 case "$TRASH_DIRECTORY" in
326 /*) ;; # absolute path is good
327 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
328 esac
329
330 # Utility functions using $TEST_RESULTS_* variables
331 nr_san_dir_leaks_ () {
332 # stderr piped to /dev/null because the directory may have
333 # been "rmdir"'d already.
334 find "$TEST_RESULTS_SAN_DIR" \
335 -type f \
336 -name "$TEST_RESULTS_SAN_FILE_PFX.*" 2>/dev/null |
337 wc -l
338 }
339
340 # If --stress was passed, run this test repeatedly in several parallel loops.
341 if test "$GIT_TEST_STRESS_STARTED" = "done"
342 then
343 : # Don't stress test again.
344 elif test -n "$stress"
345 then
346 if test -n "$stress_jobs"
347 then
348 job_count=$stress_jobs
349 elif test -n "$GIT_TEST_STRESS_LOAD"
350 then
351 job_count="$GIT_TEST_STRESS_LOAD"
352 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
353 test -n "$job_count"
354 then
355 job_count=$((2 * $job_count))
356 else
357 job_count=8
358 fi
359
360 mkdir -p "$TEST_RESULTS_DIR"
361 stressfail="$TEST_RESULTS_BASE.stress-failed"
362 rm -f "$stressfail"
363
364 stress_exit=0
365 trap '
366 kill $job_pids 2>/dev/null
367 wait
368 stress_exit=1
369 ' TERM INT HUP
370
371 job_pids=
372 job_nr=0
373 while test $job_nr -lt "$job_count"
374 do
375 (
376 GIT_TEST_STRESS_STARTED=done
377 GIT_TEST_STRESS_JOB_NR=$job_nr
378 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
379
380 trap '
381 kill $test_pid 2>/dev/null
382 wait
383 exit 1
384 ' TERM INT
385
386 cnt=1
387 while ! test -e "$stressfail" &&
388 { test -z "$stress_limit" ||
389 test $cnt -le $stress_limit ; }
390 do
391 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
392 test_pid=$!
393
394 if wait $test_pid
395 then
396 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
397 else
398 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
399 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
400 fi
401 cnt=$(($cnt + 1))
402 done
403 ) &
404 job_pids="$job_pids $!"
405 job_nr=$(($job_nr + 1))
406 done
407
408 wait
409
410 if test -f "$stressfail"
411 then
412 stress_exit=1
413 echo "Log(s) of failed test run(s):"
414 for failed_job_nr in $(sort -n "$stressfail")
415 do
416 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
417 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
418 done
419 rm -rf "$TRASH_DIRECTORY.stress-failed"
420 # Move the last one.
421 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
422 fi
423
424 exit $stress_exit
425 fi
426
427 # if --tee was passed, write the output not only to the terminal, but
428 # additionally to the file test-results/$BASENAME.out, too.
429 if test "$GIT_TEST_TEE_STARTED" = "done"
430 then
431 : # do not redirect again
432 elif test -n "$tee"
433 then
434 mkdir -p "$TEST_RESULTS_DIR"
435
436 # Make this filename available to the sub-process in case it is using
437 # --verbose-log.
438 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
439 export GIT_TEST_TEE_OUTPUT_FILE
440
441 # Truncate before calling "tee -a" to get rid of the results
442 # from any previous runs.
443 >"$GIT_TEST_TEE_OUTPUT_FILE"
444
445 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
446 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
447 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
448 exit
449 fi
450
451 if test -n "$trace" && test -n "$test_untraceable"
452 then
453 # '-x' tracing requested, but this test script can't be reliably
454 # traced, unless it is run with a Bash version supporting
455 # BASH_XTRACEFD (introduced in Bash v4.1).
456 #
457 # Perform this version check _after_ the test script was
458 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
459 # '--verbose-log', so the right shell is checked and the
460 # warning is issued only once.
461 if test -n "$BASH_VERSION" && eval '
462 test ${BASH_VERSINFO[0]} -gt 4 || {
463 test ${BASH_VERSINFO[0]} -eq 4 &&
464 test ${BASH_VERSINFO[1]} -ge 1
465 }
466 '
467 then
468 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
469 else
470 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
471 trace=
472 fi
473 fi
474 if test -n "$trace" && test -z "$verbose_log"
475 then
476 verbose=t
477 fi
478
479 # Since bash 5.0, checkwinsize is enabled by default which does
480 # update the COLUMNS variable every time a non-builtin command
481 # completes, even for non-interactive shells.
482 # Disable that since we are aiming for repeatability.
483 test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
484
485 # For repeatability, reset the environment to known value.
486 # TERM is sanitized below, after saving color control sequences.
487 LANG=C
488 LC_ALL=C
489 PAGER=cat
490 TZ=UTC
491 COLUMNS=80
492 export LANG LC_ALL PAGER TZ COLUMNS
493 EDITOR=:
494
495 # A call to "unset" with no arguments causes at least Solaris 10
496 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
497 # deriving from the command substitution clustered with the other
498 # ones.
499 unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
500 my @env = keys %ENV;
501 my $ok = join("|", qw(
502 TRACE
503 DEBUG
504 TEST
505 .*_TEST
506 PROVE
507 VALGRIND
508 UNZIP
509 PERF_
510 CURL_VERBOSE
511 TRACE_CURL
512 ));
513 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
514 print join("\n", @vars);
515 ')
516 unset XDG_CACHE_HOME
517 unset XDG_CONFIG_HOME
518 unset GITPERLLIB
519 unset GIT_TRACE2_PARENT_NAME
520 unset GIT_TRACE2_PARENT_SID
521 TEST_AUTHOR_LOCALNAME=author
522 TEST_AUTHOR_DOMAIN=example.com
523 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
524 GIT_AUTHOR_NAME='A U Thor'
525 GIT_AUTHOR_DATE='1112354055 +0200'
526 TEST_COMMITTER_LOCALNAME=committer
527 TEST_COMMITTER_DOMAIN=example.com
528 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
529 GIT_COMMITTER_NAME='C O Mitter'
530 GIT_COMMITTER_DATE='1112354055 +0200'
531 GIT_MERGE_VERBOSITY=5
532 GIT_MERGE_AUTOEDIT=no
533 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
534 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
535 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
536 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
537 export EDITOR
538
539 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
540 export GIT_DEFAULT_HASH
541 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
542 export GIT_TEST_MERGE_ALGORITHM
543
544 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
545 GIT_TRACE_BARE=1
546 export GIT_TRACE_BARE
547
548 # Some tests scan the GIT_TRACE2_EVENT feed for events, but the
549 # default depth is 2, which frequently causes issues when the
550 # events are wrapped in new regions. Set it to a sufficiently
551 # large depth to avoid custom changes in the test suite.
552 GIT_TRACE2_EVENT_NESTING=100
553 export GIT_TRACE2_EVENT_NESTING
554
555 # Use specific version of the index file format
556 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
557 then
558 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
559 export GIT_INDEX_VERSION
560 fi
561
562 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
563 then
564 GIT_PERL_FATAL_WARNINGS=1
565 export GIT_PERL_FATAL_WARNINGS
566 fi
567
568 case $GIT_TEST_FSYNC in
569 '')
570 GIT_TEST_FSYNC=0
571 export GIT_TEST_FSYNC
572 ;;
573 esac
574
575 # Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
576 # the test with valgrind and have not compiled with conflict SANITIZE
577 # options.
578 if test -n "$valgrind" ||
579 test -n "$SANITIZE_ADDRESS" ||
580 test -n "$SANITIZE_LEAK" ||
581 test -n "$TEST_NO_MALLOC_CHECK"
582 then
583 setup_malloc_check () {
584 : nothing
585 }
586 teardown_malloc_check () {
587 : nothing
588 }
589 else
590 _USE_GLIBC_TUNABLES=
591 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
592 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
593 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
594 then
595 _USE_GLIBC_TUNABLES=YesPlease
596 fi
597 setup_malloc_check () {
598 local g
599 local t
600 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
601 export MALLOC_CHECK_ MALLOC_PERTURB_
602 if test -n "$_USE_GLIBC_TUNABLES"
603 then
604 g=
605 LD_PRELOAD="libc_malloc_debug.so.0"
606 for t in \
607 glibc.malloc.check=1 \
608 glibc.malloc.perturb=165
609 do
610 g="${g#:}:$t"
611 done
612 GLIBC_TUNABLES=$g
613 export LD_PRELOAD GLIBC_TUNABLES
614 fi
615 }
616 teardown_malloc_check () {
617 unset MALLOC_CHECK_ MALLOC_PERTURB_
618 unset LD_PRELOAD GLIBC_TUNABLES
619 }
620 fi
621
622 # Protect ourselves from common misconfiguration to export
623 # CDPATH into the environment
624 unset CDPATH
625
626 unset GREP_OPTIONS
627 unset UNZIP
628
629 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
630 1|2|true)
631 GIT_TRACE=4
632 ;;
633 esac
634
635 # Line feed
636 LF='
637 '
638
639 # Single quote
640 SQ=\'
641
642 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
643 # when case-folding filenames
644 u200c=$(printf '\342\200\214')
645
646 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
647
648 test "x$TERM" != "xdumb" && (
649 test -t 1 &&
650 tput bold >/dev/null 2>&1 &&
651 tput setaf 1 >/dev/null 2>&1 &&
652 tput sgr0 >/dev/null 2>&1
653 ) &&
654 color=t
655
656 if test -n "$color"
657 then
658 # Save the color control sequences now rather than run tput
659 # each time say_color() is called. This is done for two
660 # reasons:
661 # * TERM will be changed to dumb
662 # * HOME will be changed to a temporary directory and tput
663 # might need to read ~/.terminfo from the original HOME
664 # directory to get the control sequences
665 # Note: This approach assumes the control sequences don't end
666 # in a newline for any terminal of interest (command
667 # substitutions strip trailing newlines). Given that most
668 # (all?) terminals in common use are related to ECMA-48, this
669 # shouldn't be a problem.
670 say_color_error=$(tput bold; tput setaf 1) # bold red
671 say_color_skip=$(tput setaf 4) # blue
672 say_color_warn=$(tput setaf 3) # brown/yellow
673 say_color_pass=$(tput setaf 2) # green
674 say_color_info=$(tput setaf 6) # cyan
675 say_color_reset=$(tput sgr0)
676 say_color_="" # no formatting for normal text
677 say_color () {
678 test -z "$1" && test -n "$quiet" && return
679 eval "say_color_color=\$say_color_$1"
680 shift
681 printf "%s\\n" "$say_color_color$*$say_color_reset"
682 }
683 else
684 say_color() {
685 test -z "$1" && test -n "$quiet" && return
686 shift
687 printf "%s\n" "$*"
688 }
689 fi
690
691 USER_TERM="$TERM"
692 TERM=dumb
693 export TERM USER_TERM
694
695 # What is written by tests to stdout and stderr is sent to different places
696 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
697 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
698 # stderr to #5 and #7, so that the test framework can use them (e.g. for
699 # printing errors within the test framework) independently of the test mode.
700 exec 5>&1
701 exec 6<&0
702 exec 7>&2
703
704 _error_exit () {
705 finalize_test_output
706 GIT_EXIT_OK=t
707 exit 1
708 }
709
710 error () {
711 say_color error "error: $*"
712 _error_exit
713 }
714
715 BUG () {
716 error >&7 "bug in the test script: $*"
717 }
718
719 BAIL_OUT () {
720 test $# -ne 1 && BUG "1 param"
721
722 # Do not change "Bail out! " string. It's part of TAP syntax:
723 # https://testanything.org/tap-specification.html
724 local bail_out="Bail out! "
725 local message="$1"
726
727 say_color >&5 error $bail_out "$message"
728 _error_exit
729 }
730
731 say () {
732 say_color info "$*"
733 }
734
735 if test -n "$HARNESS_ACTIVE"
736 then
737 if test "$verbose" = t || test -n "$verbose_only"
738 then
739 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
740 fi
741 fi
742
743 test "${test_description}" != "" ||
744 error "Test script did not set test_description."
745
746 if test "$help" = "t"
747 then
748 printf '%s\n' "$test_description"
749 exit 0
750 fi
751
752 if test "$verbose_log" = "t"
753 then
754 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
755 elif test "$verbose" = "t"
756 then
757 exec 4>&2 3>&1
758 else
759 exec 4>/dev/null 3>/dev/null
760 fi
761
762 # Send any "-x" output directly to stderr to avoid polluting tests
763 # which capture stderr. We can do this unconditionally since it
764 # has no effect if tracing isn't turned on.
765 #
766 # Note that this sets up the trace fd as soon as we assign the variable, so it
767 # must come after the creation of descriptor 4 above. Likewise, we must never
768 # unset this, as it has the side effect of closing descriptor 4, which we
769 # use to show verbose tests to the user.
770 #
771 # Note also that we don't need or want to export it. The tracing is local to
772 # this shell, and we would not want to influence any shells we exec.
773 BASH_XTRACEFD=4
774
775 test_failure=0
776 test_count=0
777 test_fixed=0
778 test_broken=0
779 test_success=0
780
781 test_missing_prereq=
782
783 test_external_has_tap=0
784
785 die () {
786 code=$?
787 # This is responsible for running the atexit commands even when a
788 # test script run with '--immediate' fails, or when the user hits
789 # ctrl-C, i.e. when 'test_done' is not invoked at all.
790 test_atexit_handler || code=$?
791 if test -n "$GIT_EXIT_OK"
792 then
793 exit $code
794 else
795 echo >&5 "FATAL: Unexpected exit with code $code"
796 exit 1
797 fi
798 }
799
800 GIT_EXIT_OK=
801 trap 'die' EXIT
802 # Disable '-x' tracing, because with some shells, notably dash, it
803 # prevents running the cleanup commands when a test script run with
804 # '--verbose-log -x' is interrupted.
805 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
806
807 # The user-facing functions are loaded from a separate file so that
808 # test_perf subshells can have them too
809 . "$TEST_DIRECTORY/test-lib-functions.sh"
810
811 # You are not expected to call test_ok_ and test_failure_ directly, use
812 # the test_expect_* functions instead.
813
814 test_ok_ () {
815 test_success=$(($test_success + 1))
816 say_color "" "ok $test_count - $@"
817 finalize_test_case_output ok "$@"
818 }
819
820 _invert_exit_code_failure_end_blurb () {
821 say_color warn "# faked up failures as TODO & now exiting with 0 due to --invert-exit-code"
822 }
823
824 test_failure_ () {
825 failure_label=$1
826 test_failure=$(($test_failure + 1))
827 local pfx=""
828 if test -n "$invert_exit_code" # && test -n "$HARNESS_ACTIVE"
829 then
830 pfx="# TODO induced breakage (--invert-exit-code):"
831 fi
832 say_color error "not ok $test_count - ${pfx:+$pfx }$1"
833 shift
834 printf '%s\n' "$*" | sed -e 's/^/# /'
835 if test -n "$immediate"
836 then
837 say_color error "1..$test_count"
838 if test -n "$invert_exit_code"
839 then
840 finalize_test_output
841 _invert_exit_code_failure_end_blurb
842 GIT_EXIT_OK=t
843 exit 0
844 fi
845 _error_exit
846 fi
847 finalize_test_case_output failure "$failure_label" "$@"
848 }
849
850 test_known_broken_ok_ () {
851 test_fixed=$(($test_fixed+1))
852 say_color error "ok $test_count - $1 # TODO known breakage vanished"
853 finalize_test_case_output fixed "$1"
854 }
855
856 test_known_broken_failure_ () {
857 test_broken=$(($test_broken+1))
858 say_color warn "not ok $test_count - $1 # TODO known breakage"
859 finalize_test_case_output broken "$1"
860 }
861
862 test_debug () {
863 test "$debug" = "" || eval "$1"
864 }
865
866 match_pattern_list () {
867 arg="$1"
868 shift
869 test -z "$*" && return 1
870 # We need to use "$*" to get field-splitting, but we want to
871 # disable globbing, since we are matching against an arbitrary
872 # $arg, not what's in the filesystem. Using "set -f" accomplishes
873 # that, but we must do it in a subshell to avoid impacting the
874 # rest of the script. The exit value of the subshell becomes
875 # the function's return value.
876 (
877 set -f
878 for pattern_ in $*
879 do
880 case "$arg" in
881 $pattern_)
882 exit 0
883 ;;
884 esac
885 done
886 exit 1
887 )
888 }
889
890 match_test_selector_list () {
891 operation="$1"
892 shift
893 title="$1"
894 shift
895 arg="$1"
896 shift
897 test -z "$1" && return 0
898
899 # Commas are accepted as separators.
900 OLDIFS=$IFS
901 IFS=','
902 set -- $1
903 IFS=$OLDIFS
904
905 # If the first selector is negative we include by default.
906 include=
907 case "$1" in
908 !*) include=t ;;
909 esac
910
911 for selector
912 do
913 orig_selector=$selector
914
915 positive=t
916 case "$selector" in
917 !*)
918 positive=
919 selector=${selector##?}
920 ;;
921 esac
922
923 test -z "$selector" && continue
924
925 case "$selector" in
926 *-*)
927 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
928 then
929 echo "error: $operation: invalid non-numeric in range" \
930 "start: '$orig_selector'" >&2
931 exit 1
932 fi
933 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
934 then
935 echo "error: $operation: invalid non-numeric in range" \
936 "end: '$orig_selector'" >&2
937 exit 1
938 fi
939 ;;
940 *)
941 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
942 then
943 case "$title" in *${selector}*)
944 include=$positive
945 ;;
946 esac
947 continue
948 fi
949 esac
950
951 # Short cut for "obvious" cases
952 test -z "$include" && test -z "$positive" && continue
953 test -n "$include" && test -n "$positive" && continue
954
955 case "$selector" in
956 -*)
957 if test $arg -le ${selector#-}
958 then
959 include=$positive
960 fi
961 ;;
962 *-)
963 if test $arg -ge ${selector%-}
964 then
965 include=$positive
966 fi
967 ;;
968 *-*)
969 if test ${selector%%-*} -le $arg \
970 && test $arg -le ${selector#*-}
971 then
972 include=$positive
973 fi
974 ;;
975 *)
976 if test $arg -eq $selector
977 then
978 include=$positive
979 fi
980 ;;
981 esac
982 done
983
984 test -n "$include"
985 }
986
987 maybe_teardown_verbose () {
988 test -z "$verbose_only" && return
989 exec 4>/dev/null 3>/dev/null
990 verbose=
991 }
992
993 last_verbose=t
994 maybe_setup_verbose () {
995 test -z "$verbose_only" && return
996 if match_pattern_list $test_count "$verbose_only"
997 then
998 exec 4>&2 3>&1
999 # Emit a delimiting blank line when going from
1000 # non-verbose to verbose. Within verbose mode the
1001 # delimiter is printed by test_expect_*. The choice
1002 # of the initial $last_verbose is such that before
1003 # test 1, we do not print it.
1004 test -z "$last_verbose" && echo >&3 ""
1005 verbose=t
1006 else
1007 exec 4>/dev/null 3>/dev/null
1008 verbose=
1009 fi
1010 last_verbose=$verbose
1011 }
1012
1013 maybe_teardown_valgrind () {
1014 test -z "$GIT_VALGRIND" && return
1015 GIT_VALGRIND_ENABLED=
1016 }
1017
1018 maybe_setup_valgrind () {
1019 test -z "$GIT_VALGRIND" && return
1020 if test -z "$valgrind_only"
1021 then
1022 GIT_VALGRIND_ENABLED=t
1023 return
1024 fi
1025 GIT_VALGRIND_ENABLED=
1026 if match_pattern_list $test_count "$valgrind_only"
1027 then
1028 GIT_VALGRIND_ENABLED=t
1029 fi
1030 }
1031
1032 trace_level_=0
1033 want_trace () {
1034 test "$trace" = t && {
1035 test "$verbose" = t || test "$verbose_log" = t
1036 }
1037 }
1038
1039 # This is a separate function because some tests use
1040 # "return" to end a test_expect_success block early
1041 # (and we want to make sure we run any cleanup like
1042 # "set +x").
1043 test_eval_inner_ () {
1044 # Do not add anything extra (including LF) after '$*'
1045 eval "
1046 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1047 $*"
1048 }
1049
1050 test_eval_ () {
1051 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1052 # with non-test commands. But once in "set -x" mode, we cannot prevent
1053 # the shell from printing the "set +x" to turn it off (nor the saving
1054 # of $? before that). But we can make sure that the output goes to
1055 # /dev/null.
1056 #
1057 # There are a few subtleties here:
1058 #
1059 # - we have to redirect descriptor 4 in addition to 2, to cover
1060 # BASH_XTRACEFD
1061 #
1062 # - the actual eval has to come before the redirection block (since
1063 # it needs to see descriptor 4 to set up its stderr)
1064 #
1065 # - likewise, any error message we print must be outside the block to
1066 # access descriptor 4
1067 #
1068 # - checking $? has to come immediately after the eval, but it must
1069 # be _inside_ the block to avoid polluting the "set -x" output
1070 #
1071
1072 test_eval_inner_ "$@" </dev/null >&3 2>&4
1073 {
1074 test_eval_ret_=$?
1075 if want_trace
1076 then
1077 test 1 = $trace_level_ && set +x
1078 trace_level_=$(($trace_level_-1))
1079 fi
1080 } 2>/dev/null 4>&2
1081
1082 if test "$test_eval_ret_" != 0 && want_trace
1083 then
1084 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1085 fi
1086 return $test_eval_ret_
1087 }
1088
1089 test_run_ () {
1090 test_cleanup=:
1091 expecting_failure=$2
1092
1093 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
1094 # turn off tracing for this test-eval, as it simply creates
1095 # confusing noise in the "-x" output
1096 trace_tmp=$trace
1097 trace=
1098 # 117 is magic because it is unlikely to match the exit
1099 # code of other programs
1100 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
1101 then
1102 BUG "broken &&-chain or run-away HERE-DOC: $1"
1103 fi
1104 trace=$trace_tmp
1105 fi
1106
1107 setup_malloc_check
1108 test_eval_ "$1"
1109 eval_ret=$?
1110 teardown_malloc_check
1111
1112 if test -z "$immediate" || test $eval_ret = 0 ||
1113 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1114 then
1115 setup_malloc_check
1116 test_eval_ "$test_cleanup"
1117 teardown_malloc_check
1118 fi
1119 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1120 then
1121 echo ""
1122 fi
1123 return "$eval_ret"
1124 }
1125
1126 test_start_ () {
1127 test_count=$(($test_count+1))
1128 maybe_setup_verbose
1129 maybe_setup_valgrind
1130 start_test_case_output "$@"
1131 }
1132
1133 test_finish_ () {
1134 echo >&3 ""
1135 maybe_teardown_valgrind
1136 maybe_teardown_verbose
1137 if test -n "$GIT_TEST_TEE_OFFSET"
1138 then
1139 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1140 "$GIT_TEST_TEE_OUTPUT_FILE")
1141 fi
1142 }
1143
1144 test_skip () {
1145 to_skip=
1146 skipped_reason=
1147 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
1148 then
1149 to_skip=t
1150 skipped_reason="GIT_SKIP_TESTS"
1151 fi
1152 if test -z "$to_skip" && test -n "$run_list" &&
1153 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1154 then
1155 to_skip=t
1156 skipped_reason="--run"
1157 fi
1158 if test -z "$to_skip" && test -n "$test_prereq" &&
1159 ! test_have_prereq "$test_prereq"
1160 then
1161 to_skip=t
1162
1163 of_prereq=
1164 if test "$missing_prereq" != "$test_prereq"
1165 then
1166 of_prereq=" of $test_prereq"
1167 fi
1168 skipped_reason="missing $missing_prereq${of_prereq}"
1169
1170 # Keep a list of all the missing prereq for result aggregation
1171 if test -z "$missing_prereq"
1172 then
1173 test_missing_prereq=$missing_prereq
1174 else
1175 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1176 fi
1177 fi
1178
1179 case "$to_skip" in
1180 t)
1181
1182 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1183 : true
1184 finalize_test_case_output skip "$@"
1185 ;;
1186 *)
1187 false
1188 ;;
1189 esac
1190 }
1191
1192 # stub; perf-lib overrides it
1193 test_at_end_hook_ () {
1194 :
1195 }
1196
1197 test_atexit_cleanup=:
1198 test_atexit_handler () {
1199 # In a succeeding test script 'test_atexit_handler' is invoked
1200 # twice: first from 'test_done', then from 'die' in the trap on
1201 # EXIT.
1202 # This condition and resetting 'test_atexit_cleanup' below makes
1203 # sure that the registered cleanup commands are run only once.
1204 test : != "$test_atexit_cleanup" || return 0
1205
1206 setup_malloc_check
1207 test_eval_ "$test_atexit_cleanup"
1208 test_atexit_cleanup=:
1209 teardown_malloc_check
1210 }
1211
1212 sanitize_leak_log_message_ () {
1213 local new="$1" &&
1214 local old="$2" &&
1215 local file="$3" &&
1216
1217 printf "With SANITIZE=leak at exit we have %d leak logs, but started with %d
1218
1219 This means that we have a blindspot where git is leaking but we're
1220 losing the exit code somewhere, or not propagating it appropriately
1221 upwards!
1222
1223 See the logs at \"%s.*\";
1224 those logs are reproduced below." \
1225 "$new" "$old" "$file"
1226 }
1227
1228 check_test_results_san_file_ () {
1229 if test -z "$TEST_RESULTS_SAN_FILE"
1230 then
1231 return
1232 fi &&
1233 local old="$TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP" &&
1234 local new="$(nr_san_dir_leaks_)" &&
1235
1236 if test $new -le $old
1237 then
1238 return
1239 fi &&
1240 local out="$(sanitize_leak_log_message_ "$new" "$old" "$TEST_RESULTS_SAN_FILE")" &&
1241 say_color error "$out" &&
1242 if test "$old" != 0
1243 then
1244 echo &&
1245 say_color error "The logs include output from past runs to avoid" &&
1246 say_color error "that remove 'test-results' between runs."
1247 fi &&
1248 say_color error "$(cat "$TEST_RESULTS_SAN_FILE".*)" &&
1249
1250 if test -n "$passes_sanitize_leak" && test "$test_failure" = 0
1251 then
1252 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, exit non-zero!" &&
1253 invert_exit_code=t
1254 elif test -n "$passes_sanitize_leak"
1255 then
1256 say "As TEST_PASSES_SANITIZE_LEAK=true and our logs show we're leaking, and we're failing for other reasons too..." &&
1257 invert_exit_code=
1258 elif test -n "$sanitize_leak_check" && test "$test_failure" = 0
1259 then
1260 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1261 invert_exit_code=
1262 elif test -n "$sanitize_leak_check"
1263 then
1264 say "As TEST_PASSES_SANITIZE_LEAK=true isn't set the above leak is 'ok' with GIT_TEST_PASSING_SANITIZE_LEAK=check" &&
1265 invert_exit_code=t
1266 else
1267 say "With GIT_TEST_SANITIZE_LEAK_LOG=true our logs revealed a memory leak, exit non-zero!" &&
1268 invert_exit_code=t
1269 fi
1270 }
1271
1272 test_done () {
1273 # Run the atexit commands _before_ the trash directory is
1274 # removed, so the commands can access pidfiles and socket files.
1275 test_atexit_handler
1276
1277 finalize_test_output
1278
1279 if test -z "$HARNESS_ACTIVE"
1280 then
1281 mkdir -p "$TEST_RESULTS_DIR"
1282
1283 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1284 total $test_count
1285 success $test_success
1286 fixed $test_fixed
1287 broken $test_broken
1288 failed $test_failure
1289 missing_prereq $test_missing_prereq
1290
1291 EOF
1292 fi
1293
1294 if test "$test_fixed" != 0
1295 then
1296 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1297 fi
1298 if test "$test_broken" != 0
1299 then
1300 say_color warn "# still have $test_broken known breakage(s)"
1301 fi
1302 if test "$test_broken" != 0 || test "$test_fixed" != 0
1303 then
1304 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1305 msg="remaining $test_remaining test(s)"
1306 else
1307 test_remaining=$test_count
1308 msg="$test_count test(s)"
1309 fi
1310 case "$test_failure" in
1311 0)
1312 if test $test_remaining -gt 0
1313 then
1314 say_color pass "# passed all $msg"
1315 fi
1316
1317 # Maybe print SKIP message
1318 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1319 case "$test_count" in
1320 0)
1321 say "1..$test_count${skip_all:+ $skip_all}"
1322 ;;
1323 *)
1324 test -z "$skip_all" ||
1325 say_color warn "$skip_all"
1326 say "1..$test_count"
1327 ;;
1328 esac
1329
1330 if test -n "$stress" && test -n "$invert_exit_code"
1331 then
1332 # We're about to move our "$TRASH_DIRECTORY"
1333 # to "$TRASH_DIRECTORY.stress-failed" if
1334 # --stress is combined with
1335 # --invert-exit-code.
1336 say "with --stress and --invert-exit-code we're not removing '$TRASH_DIRECTORY'"
1337 elif test -z "$debug" && test -n "$remove_trash"
1338 then
1339 test -d "$TRASH_DIRECTORY" ||
1340 error "Tests passed but trash directory already removed before test cleanup; aborting"
1341
1342 cd "$TRASH_DIRECTORY/.." &&
1343 rm -fr "$TRASH_DIRECTORY" || {
1344 # try again in a bit
1345 sleep 5;
1346 rm -fr "$TRASH_DIRECTORY"
1347 } ||
1348 error "Tests passed but test cleanup failed; aborting"
1349 fi
1350
1351 check_test_results_san_file_ "$test_failure"
1352
1353 if test -z "$skip_all" && test -n "$invert_exit_code"
1354 then
1355 say_color warn "# faking up non-zero exit with --invert-exit-code"
1356 GIT_EXIT_OK=t
1357 exit 1
1358 fi
1359
1360 test_at_end_hook_
1361
1362 GIT_EXIT_OK=t
1363 exit 0 ;;
1364
1365 *)
1366 say_color error "# failed $test_failure among $msg"
1367 say "1..$test_count"
1368
1369 check_test_results_san_file_ "$test_failure"
1370
1371 if test -n "$invert_exit_code"
1372 then
1373 _invert_exit_code_failure_end_blurb
1374 GIT_EXIT_OK=t
1375 exit 0
1376 fi
1377
1378 GIT_EXIT_OK=t
1379 exit 1 ;;
1380
1381 esac
1382 }
1383
1384 if test -n "$valgrind"
1385 then
1386 make_symlink () {
1387 test -h "$2" &&
1388 test "$1" = "$(readlink "$2")" || {
1389 # be super paranoid
1390 if mkdir "$2".lock
1391 then
1392 rm -f "$2" &&
1393 ln -s "$1" "$2" &&
1394 rm -r "$2".lock
1395 else
1396 while test -d "$2".lock
1397 do
1398 say "Waiting for lock on $2."
1399 sleep 1
1400 done
1401 fi
1402 }
1403 }
1404
1405 make_valgrind_symlink () {
1406 # handle only executables, unless they are shell libraries that
1407 # need to be in the exec-path.
1408 test -x "$1" ||
1409 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1410 return;
1411
1412 base=$(basename "$1")
1413 case "$base" in
1414 test-*)
1415 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1416 ;;
1417 *)
1418 symlink_target="$GIT_BUILD_DIR/$base"
1419 ;;
1420 esac
1421 # do not override scripts
1422 if test -x "$symlink_target" &&
1423 test ! -d "$symlink_target" &&
1424 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1425 then
1426 symlink_target=../valgrind.sh
1427 fi
1428 case "$base" in
1429 *.sh|*.perl)
1430 symlink_target=../unprocessed-script
1431 esac
1432 # create the link, or replace it if it is out of date
1433 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1434 }
1435
1436 # override all git executables in TEST_DIRECTORY/..
1437 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1438 mkdir -p "$GIT_VALGRIND"/bin
1439 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1440 do
1441 make_valgrind_symlink $file
1442 done
1443 # special-case the mergetools loadables
1444 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1445 OLDIFS=$IFS
1446 IFS=:
1447 for path in $PATH
1448 do
1449 ls "$path"/git-* 2> /dev/null |
1450 while read file
1451 do
1452 make_valgrind_symlink "$file"
1453 done
1454 done
1455 IFS=$OLDIFS
1456 PATH=$GIT_VALGRIND/bin:$PATH
1457 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1458 export GIT_VALGRIND
1459 GIT_VALGRIND_MODE="$valgrind"
1460 export GIT_VALGRIND_MODE
1461 GIT_VALGRIND_ENABLED=t
1462 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1463 export GIT_VALGRIND_ENABLED
1464 elif test -n "$GIT_TEST_INSTALLED"
1465 then
1466 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1467 error "Cannot run git from $GIT_TEST_INSTALLED."
1468 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1469 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1470 else # normal case, use ../bin-wrappers only unless $with_dashes:
1471 if test -n "$no_bin_wrappers"
1472 then
1473 with_dashes=t
1474 else
1475 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1476 if ! test -x "$git_bin_dir/git"
1477 then
1478 if test -z "$with_dashes"
1479 then
1480 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1481 fi
1482 with_dashes=t
1483 fi
1484 PATH="$git_bin_dir:$PATH"
1485 fi
1486 GIT_EXEC_PATH=$GIT_BUILD_DIR
1487 if test -n "$with_dashes"
1488 then
1489 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1490 fi
1491 fi
1492 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1493 GIT_CONFIG_NOSYSTEM=1
1494 GIT_ATTR_NOSYSTEM=1
1495 GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1496 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1497
1498 if test -z "$GIT_TEST_CMP"
1499 then
1500 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1501 then
1502 GIT_TEST_CMP="$DIFF -c"
1503 else
1504 GIT_TEST_CMP="$DIFF -u"
1505 fi
1506 fi
1507
1508 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1509 export GITPERLLIB
1510 test -d "$GIT_BUILD_DIR"/templates/blt || {
1511 BAIL_OUT "You haven't built things yet, have you?"
1512 }
1513
1514 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1515 then
1516 BAIL_OUT 'You need to build test-tool; Run "make t/helper/test-tool" in the source (toplevel) directory'
1517 fi
1518
1519 # Are we running this test at all?
1520 remove_trash=
1521 this_test=${0##*/}
1522 this_test=${this_test%%-*}
1523 if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
1524 then
1525 say_color info >&3 "skipping test $this_test altogether"
1526 skip_all="skip all tests in $this_test"
1527 test_done
1528 fi
1529
1530 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK () {
1531 BAIL_OUT "$1 has no effect except when compiled with SANITIZE=leak"
1532 }
1533
1534 if test -n "$SANITIZE_LEAK"
1535 then
1536 # Normalize with test_bool_env
1537 passes_sanitize_leak=
1538
1539 # We need to see TEST_PASSES_SANITIZE_LEAK in "test-tool
1540 # env-helper" (via test_bool_env)
1541 export TEST_PASSES_SANITIZE_LEAK
1542 if test_bool_env TEST_PASSES_SANITIZE_LEAK false
1543 then
1544 passes_sanitize_leak=t
1545 fi
1546
1547 if test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check"
1548 then
1549 sanitize_leak_check=t
1550 if test -n "$invert_exit_code"
1551 then
1552 BAIL_OUT "cannot use --invert-exit-code under GIT_TEST_PASSING_SANITIZE_LEAK=check"
1553 fi
1554
1555 if test -z "$passes_sanitize_leak"
1556 then
1557 say "in GIT_TEST_PASSING_SANITIZE_LEAK=check mode, setting --invert-exit-code for TEST_PASSES_SANITIZE_LEAK != true"
1558 invert_exit_code=t
1559 fi
1560 elif test -z "$passes_sanitize_leak" &&
1561 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1562 then
1563 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1564 test_done
1565 fi
1566
1567 if test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1568 then
1569 if ! mkdir -p "$TEST_RESULTS_SAN_DIR"
1570 then
1571 BAIL_OUT "cannot create $TEST_RESULTS_SAN_DIR"
1572 fi &&
1573 TEST_RESULTS_SAN_FILE="$TEST_RESULTS_SAN_DIR/$TEST_RESULTS_SAN_FILE_PFX"
1574
1575 # In case "test-results" is left over from a previous
1576 # run: Only report if new leaks show up.
1577 TEST_RESULTS_SAN_DIR_NR_LEAKS_STARTUP=$(nr_san_dir_leaks_)
1578
1579 # Don't litter *.leak dirs if there was nothing to report
1580 test_atexit "rmdir \"$TEST_RESULTS_SAN_DIR\" 2>/dev/null || :"
1581
1582 prepend_var LSAN_OPTIONS : dedup_token_length=9999
1583 prepend_var LSAN_OPTIONS : log_exe_name=1
1584 prepend_var LSAN_OPTIONS : log_path=\"$TEST_RESULTS_SAN_FILE\"
1585 export LSAN_OPTIONS
1586 fi
1587 elif test "$GIT_TEST_PASSING_SANITIZE_LEAK" = "check" ||
1588 test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1589 then
1590 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_PASSING_SANITIZE_LEAK=true"
1591 elif test_bool_env GIT_TEST_SANITIZE_LEAK_LOG false
1592 then
1593 BAIL_OUT_ENV_NEEDS_SANITIZE_LEAK "GIT_TEST_SANITIZE_LEAK_LOG=true"
1594 fi
1595
1596 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0
1597 then
1598 "$PERL_PATH" "$TEST_DIRECTORY/chainlint.pl" "$0" ||
1599 BUG "lint error (see '?!...!? annotations above)"
1600 fi
1601
1602 # Last-minute variable setup
1603 USER_HOME="$HOME"
1604 HOME="$TRASH_DIRECTORY"
1605 GNUPGHOME="$HOME/gnupg-home-not-used"
1606 export HOME GNUPGHOME USER_HOME
1607
1608 # "rm -rf" existing trash directory, even if a previous run left it
1609 # with bad permissions.
1610 remove_trash_directory () {
1611 dir="$1"
1612 if ! rm -rf "$dir" 2>/dev/null
1613 then
1614 chmod -R u+rwx "$dir"
1615 rm -rf "$dir"
1616 fi
1617 ! test -d "$dir"
1618 }
1619
1620 # Test repository
1621 remove_trash_directory "$TRASH_DIRECTORY" || {
1622 BAIL_OUT 'cannot prepare test area'
1623 }
1624
1625 remove_trash=t
1626 if test -z "$TEST_NO_CREATE_REPO"
1627 then
1628 git init \
1629 ${TEST_CREATE_REPO_NO_TEMPLATE:+--template=} \
1630 "$TRASH_DIRECTORY" >&3 2>&4 ||
1631 error "cannot run git init"
1632 else
1633 mkdir -p "$TRASH_DIRECTORY"
1634 fi
1635
1636 # Use -P to resolve symlinks in our working directory so that the cwd
1637 # in subprocesses like git equals our $PWD (for pathname comparisons).
1638 cd -P "$TRASH_DIRECTORY" || BAIL_OUT "cannot cd -P to \"$TRASH_DIRECTORY\""
1639
1640 start_test_output "$0"
1641
1642 # Convenience
1643 # A regexp to match 5 and 35 hexdigits
1644 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1645 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1646
1647 test_oid_init
1648
1649 ZERO_OID=$(test_oid zero)
1650 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1651 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1652 EMPTY_TREE=$(test_oid empty_tree)
1653 EMPTY_BLOB=$(test_oid empty_blob)
1654
1655 # Provide an implementation of the 'yes' utility; the upper bound
1656 # limit is there to help Windows that cannot stop this loop from
1657 # wasting cycles when the downstream stops reading, so do not be
1658 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1659 # limit the output of the yes utility", 2016-02-02)
1660 yes () {
1661 if test $# = 0
1662 then
1663 y=y
1664 else
1665 y="$*"
1666 fi
1667
1668 i=0
1669 while test $i -lt 99
1670 do
1671 echo "$y"
1672 i=$(($i+1))
1673 done
1674 }
1675
1676 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1677 # thus needs to be set up really early, and set an internal variable
1678 # for convenience so the hot test_set_prereq() codepath doesn't need
1679 # to call "test-tool env-helper" (via test_bool_env). Only do that work
1680 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1681 GIT_TEST_FAIL_PREREQS_INTERNAL=
1682 if test -n "$GIT_TEST_FAIL_PREREQS"
1683 then
1684 if test_bool_env GIT_TEST_FAIL_PREREQS false
1685 then
1686 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1687 test_set_prereq FAIL_PREREQS
1688 fi
1689 else
1690 test_lazy_prereq FAIL_PREREQS '
1691 test_bool_env GIT_TEST_FAIL_PREREQS false
1692 '
1693 fi
1694
1695 # Fix some commands on Windows, and other OS-specific things
1696 uname_s=$(uname -s)
1697 case $uname_s in
1698 *MINGW*)
1699 # Windows has its own (incompatible) sort and find
1700 sort () {
1701 /usr/bin/sort "$@"
1702 }
1703 find () {
1704 /usr/bin/find "$@"
1705 }
1706 # git sees Windows-style pwd
1707 pwd () {
1708 builtin pwd -W
1709 }
1710 # no POSIX permissions
1711 # backslashes in pathspec are converted to '/'
1712 # exec does not inherit the PID
1713 test_set_prereq MINGW
1714 test_set_prereq NATIVE_CRLF
1715 test_set_prereq SED_STRIPS_CR
1716 test_set_prereq GREP_STRIPS_CR
1717 test_set_prereq WINDOWS
1718 GIT_TEST_CMP="GIT_DIR=/dev/null git diff --no-index --ignore-cr-at-eol --"
1719 ;;
1720 *CYGWIN*)
1721 test_set_prereq POSIXPERM
1722 test_set_prereq EXECKEEPSPID
1723 test_set_prereq CYGWIN
1724 test_set_prereq SED_STRIPS_CR
1725 test_set_prereq GREP_STRIPS_CR
1726 test_set_prereq WINDOWS
1727 ;;
1728 *)
1729 test_set_prereq POSIXPERM
1730 test_set_prereq BSLASHPSPEC
1731 test_set_prereq EXECKEEPSPID
1732 ;;
1733 esac
1734
1735 # Detect arches where a few things don't work
1736 uname_m=$(uname -m)
1737 case $uname_m in
1738 parisc* | hppa*)
1739 test_set_prereq HPPA
1740 ;;
1741 esac
1742
1743 test_set_prereq REFFILES
1744
1745 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1746 test -z "$NO_CURL" && test_set_prereq LIBCURL
1747 test -z "$NO_PERL" && test_set_prereq PERL
1748 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1749 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1750 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1751 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1752 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1753 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1754 test -n "$GIT_VALGRIND_ENABLED" && test_set_prereq VALGRIND
1755
1756 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1757 then
1758 GIT_TEST_CHECK_CACHE_TREE=true
1759 export GIT_TEST_CHECK_CACHE_TREE
1760 fi
1761
1762 test_lazy_prereq PIPE '
1763 # test whether the filesystem supports FIFOs
1764 test_have_prereq !MINGW,!CYGWIN &&
1765 rm -f testfifo && mkfifo testfifo
1766 '
1767
1768 test_lazy_prereq SYMLINKS '
1769 # test whether the filesystem supports symbolic links
1770 ln -s x y && test -h y
1771 '
1772
1773 test_lazy_prereq SYMLINKS_WINDOWS '
1774 # test whether symbolic links are enabled on Windows
1775 test_have_prereq MINGW &&
1776 cmd //c "mklink y x" &> /dev/null && test -h y
1777 '
1778
1779 test_lazy_prereq FILEMODE '
1780 test "$(git config --bool core.filemode)" = true
1781 '
1782
1783 test_lazy_prereq CASE_INSENSITIVE_FS '
1784 echo good >CamelCase &&
1785 echo bad >camelcase &&
1786 test "$(cat CamelCase)" != good
1787 '
1788
1789 test_lazy_prereq FUNNYNAMES '
1790 test_have_prereq !MINGW &&
1791 touch -- \
1792 "FUNNYNAMES tab embedded" \
1793 "FUNNYNAMES \"quote embedded\"" \
1794 "FUNNYNAMES newline
1795 embedded" 2>/dev/null &&
1796 rm -- \
1797 "FUNNYNAMES tab embedded" \
1798 "FUNNYNAMES \"quote embedded\"" \
1799 "FUNNYNAMES newline
1800 embedded" 2>/dev/null
1801 '
1802
1803 test_lazy_prereq UTF8_NFD_TO_NFC '
1804 # check whether FS converts nfd unicode to nfc
1805 auml=$(printf "\303\244")
1806 aumlcdiar=$(printf "\141\314\210")
1807 >"$auml" &&
1808 test -f "$aumlcdiar"
1809 '
1810
1811 test_lazy_prereq AUTOIDENT '
1812 sane_unset GIT_AUTHOR_NAME &&
1813 sane_unset GIT_AUTHOR_EMAIL &&
1814 git var GIT_AUTHOR_IDENT
1815 '
1816
1817 test_lazy_prereq EXPENSIVE '
1818 test -n "$GIT_TEST_LONG"
1819 '
1820
1821 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1822 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1823 '
1824
1825 test_lazy_prereq USR_BIN_TIME '
1826 test -x /usr/bin/time
1827 '
1828
1829 test_lazy_prereq NOT_ROOT '
1830 uid=$(id -u) &&
1831 test "$uid" != 0
1832 '
1833
1834 test_lazy_prereq JGIT '
1835 jgit --version
1836 '
1837
1838 # SANITY is about "can you correctly predict what the filesystem would
1839 # do by only looking at the permission bits of the files and
1840 # directories?" A typical example of !SANITY is running the test
1841 # suite as root, where a test may expect "chmod -r file && cat file"
1842 # to fail because file is supposed to be unreadable after a successful
1843 # chmod. In an environment (i.e. combination of what filesystem is
1844 # being used and who is running the tests) that lacks SANITY, you may
1845 # be able to delete or create a file when the containing directory
1846 # doesn't have write permissions, or access a file even if the
1847 # containing directory doesn't have read or execute permissions.
1848
1849 test_lazy_prereq SANITY '
1850 mkdir SANETESTD.1 SANETESTD.2 &&
1851
1852 chmod +w SANETESTD.1 SANETESTD.2 &&
1853 >SANETESTD.1/x 2>SANETESTD.2/x &&
1854 chmod -w SANETESTD.1 &&
1855 chmod -r SANETESTD.1/x &&
1856 chmod -rx SANETESTD.2 ||
1857 BUG "cannot prepare SANETESTD"
1858
1859 ! test -r SANETESTD.1/x &&
1860 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1861 status=$?
1862
1863 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1864 rm -rf SANETESTD.1 SANETESTD.2 ||
1865 BUG "cannot clean SANETESTD"
1866 return $status
1867 '
1868
1869 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1870 GIT_UNZIP=${GIT_UNZIP:-unzip}
1871 test_lazy_prereq UNZIP '
1872 "$GIT_UNZIP" -v
1873 test $? -ne 127
1874 '
1875
1876 run_with_limited_cmdline () {
1877 (ulimit -s 128 && "$@")
1878 }
1879
1880 test_lazy_prereq CMDLINE_LIMIT '
1881 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1882 run_with_limited_cmdline true
1883 '
1884
1885 run_with_limited_stack () {
1886 (ulimit -s 128 && "$@")
1887 }
1888
1889 test_lazy_prereq ULIMIT_STACK_SIZE '
1890 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1891 run_with_limited_stack true
1892 '
1893
1894 run_with_limited_open_files () {
1895 (ulimit -n 32 && "$@")
1896 }
1897
1898 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1899 test_have_prereq !MINGW,!CYGWIN &&
1900 run_with_limited_open_files true
1901 '
1902
1903 build_option () {
1904 git version --build-options |
1905 sed -ne "s/^$1: //p"
1906 }
1907
1908 test_lazy_prereq SIZE_T_IS_64BIT '
1909 test 8 -eq "$(build_option sizeof-size_t)"
1910 '
1911
1912 test_lazy_prereq LONG_IS_64BIT '
1913 test 8 -le "$(build_option sizeof-long)"
1914 '
1915
1916 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1917 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1918
1919 test_lazy_prereq CURL '
1920 curl --version
1921 '
1922
1923 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1924 # which will not work with other hash algorithms and tests that work but don't
1925 # test anything meaningful (e.g. special values which cause short collisions).
1926 test_lazy_prereq SHA1 '
1927 case "$GIT_DEFAULT_HASH" in
1928 sha1) true ;;
1929 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1930 *) false ;;
1931 esac
1932 '
1933
1934 # Ensure that no test accidentally triggers a Git command
1935 # that runs the actual maintenance scheduler, affecting a user's
1936 # system permanently.
1937 # Tests that verify the scheduler integration must set this locally
1938 # to avoid errors.
1939 GIT_TEST_MAINT_SCHEDULER="none:exit 1"
1940
1941 # Does this platform support `git fsmonitor--daemon`
1942 #
1943 test_lazy_prereq FSMONITOR_DAEMON '
1944 git version --build-options >output &&
1945 grep "feature: fsmonitor--daemon" output
1946 '